--- /dev/null	Sat May 10 12:09:49 2014
+++ new/usr/src/lib/libmvec/common/__vTBL_sincos.c	Sat May 10 12:09:49 2014
@@ -0,0 +1,334 @@
+/*
+ * CDDL HEADER START
+ *
+ * The contents of this file are subject to the terms of the
+ * Common Development and Distribution License (the "License").
+ * You may not use this file except in compliance with the License.
+ *
+ * You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
+ * or http://www.opensolaris.org/os/licensing.
+ * See the License for the specific language governing permissions
+ * and limitations under the License.
+ *
+ * When distributing Covered Code, include this CDDL HEADER in each
+ * file and include the License file at usr/src/OPENSOLARIS.LICENSE.
+ * If applicable, add the following below this CDDL HEADER, with the
+ * fields enclosed by brackets "[]" replaced with your own identifying
+ * information: Portions Copyright [yyyy] [name of copyright owner]
+ *
+ * CDDL HEADER END
+ */
+
+/*
+ * Copyright 2011 Nexenta Systems, Inc.  All rights reserved.
+ */
+/*
+ * Copyright 2006 Sun Microsystems, Inc.  All rights reserved.
+ * Use is subject to license terms.
+ */
+
+const double __vlibm_TBL_sincos_hi[] = {
+ 1.55614992773556032e-01, 9.87817783816471895e-01,
+-1.55614992773556032e-01,-9.87817783816471895e-01,
+ 1.59472458931843419e-01, 9.87202377854830448e-01,
+-1.59472458931843419e-01,-9.87202377854830448e-01,
+ 1.63327491736612845e-01, 9.86571908399497599e-01,
+-1.63327491736612845e-01,-9.86571908399497599e-01,
+ 1.67180032364806747e-01, 9.85926385070661437e-01,
+-1.67180032364806747e-01,-9.85926385070661437e-01,
+ 1.71030022031395029e-01, 9.85265817718213865e-01,
+-1.71030022031395029e-01,-9.85265817718213865e-01,
+ 1.74877401990272185e-01, 9.84590216421599829e-01,
+-1.74877401990272185e-01,-9.84590216421599829e-01,
+ 1.78722113535153659e-01, 9.83899591489663994e-01,
+-1.78722113535153659e-01,-9.83899591489663994e-01,
+ 1.82564098000471547e-01, 9.83193953460493097e-01,
+-1.82564098000471547e-01,-9.83193953460493097e-01,
+ 1.86403296762269882e-01, 9.82473313101255297e-01,
+-1.86403296762269882e-01,-9.82473313101255297e-01,
+ 1.90239651239099056e-01, 9.81737681408035745e-01,
+-1.90239651239099056e-01,-9.81737681408035745e-01,
+ 1.94073102892909799e-01, 9.80987069605669171e-01,
+-1.94073102892909799e-01,-9.80987069605669171e-01,
+ 1.97903593229946273e-01, 9.80221489147568126e-01,
+-1.97903593229946273e-01,-9.80221489147568126e-01,
+ 2.01731063801638799e-01, 9.79440951715548347e-01,
+-2.01731063801638799e-01,-9.79440951715548347e-01,
+ 2.05555456205495507e-01, 9.78645469219650899e-01,
+-2.05555456205495507e-01,-9.78645469219650899e-01,
+ 2.09376712085993649e-01, 9.77835053797959763e-01,
+-2.09376712085993649e-01,-9.77835053797959763e-01,
+ 2.13194773135469889e-01, 9.77009717816417433e-01,
+-2.13194773135469889e-01,-9.77009717816417433e-01,
+ 2.17009581095010146e-01, 9.76169473868635285e-01,
+-2.17009581095010146e-01,-9.76169473868635285e-01,
+ 2.20821077755338491e-01, 9.75314334775702285e-01,
+-2.20821077755338491e-01,-9.75314334775702285e-01,
+ 2.24629204957705303e-01, 9.74444313585988930e-01,
+-2.24629204957705303e-01,-9.74444313585988930e-01,
+ 2.28433904594774750e-01, 9.73559423574948180e-01,
+-2.28433904594774750e-01,-9.73559423574948180e-01,
+ 2.32235118611511471e-01, 9.72659678244912729e-01,
+-2.32235118611511471e-01,-9.72659678244912729e-01,
+ 2.36032789006066335e-01, 9.71745091324889509e-01,
+-2.36032789006066335e-01,-9.71745091324889509e-01,
+ 2.39826857830661572e-01, 9.70815676770349412e-01,
+-2.39826857830661572e-01,-9.70815676770349412e-01,
+ 2.43617267192474896e-01, 9.69871448763015342e-01,
+-2.43617267192474896e-01,-9.69871448763015342e-01,
+ 2.47403959254522937e-01, 9.68912421710644733e-01,
+-2.47403959254522937e-01,-9.68912421710644733e-01,
+ 2.54965960415878490e-01, 9.66950029230677854e-01,
+-2.54965960415878490e-01,-9.66950029230677854e-01,
+ 2.62512399769153304e-01, 9.64928619104771013e-01,
+-2.62512399769153304e-01,-9.64928619104771013e-01,
+ 2.70042816718585044e-01, 9.62848314709379705e-01,
+-2.70042816718585044e-01,-9.62848314709379705e-01,
+ 2.77556751646336308e-01, 9.60709243015561931e-01,
+-2.77556751646336308e-01,-9.60709243015561931e-01,
+ 2.85053745940547443e-01, 9.58511534581228619e-01,
+-2.85053745940547443e-01,-9.58511534581228619e-01,
+ 2.92533342023327536e-01, 9.56255323543175328e-01,
+-2.92533342023327536e-01,-9.56255323543175328e-01,
+ 2.99995083378683025e-01, 9.53940747608894690e-01,
+-2.99995083378683025e-01,-9.53940747608894690e-01,
+ 3.07438514580380851e-01, 9.51567948048172241e-01,
+-3.07438514580380851e-01,-9.51567948048172241e-01,
+ 3.14863181319745222e-01, 9.49137069684462986e-01,
+-3.14863181319745222e-01,-9.49137069684462986e-01,
+ 3.22268630433386605e-01, 9.46648260886053361e-01,
+-3.22268630433386605e-01,-9.46648260886053361e-01,
+ 3.29654409930860148e-01, 9.44101673557004362e-01,
+-3.29654409930860148e-01,-9.44101673557004362e-01,
+ 3.37020069022253066e-01, 9.41497463127881073e-01,
+-3.37020069022253066e-01,-9.41497463127881073e-01,
+ 3.44365158145698402e-01, 9.38835788546265482e-01,
+-3.44365158145698402e-01,-9.38835788546265482e-01,
+ 3.51689228994814085e-01, 9.36116812267055343e-01,
+-3.51689228994814085e-01,-9.36116812267055343e-01,
+ 3.58991834546065036e-01, 9.33340700242548449e-01,
+-3.58991834546065036e-01,-9.33340700242548449e-01,
+ 3.66272529086047571e-01, 9.30507621912314287e-01,
+-3.66272529086047571e-01,-9.30507621912314287e-01,
+ 3.73530868238692970e-01, 9.27617750192851864e-01,
+-3.73530868238692970e-01,-9.27617750192851864e-01,
+ 3.80766408992390171e-01, 9.24671261467036043e-01,
+-3.80766408992390171e-01,-9.24671261467036043e-01,
+ 3.87978709727025028e-01, 9.21668335573351927e-01,
+-3.87978709727025028e-01,-9.21668335573351927e-01,
+ 3.95167330240934256e-01, 9.18609155794918308e-01,
+-3.95167330240934256e-01,-9.18609155794918308e-01,
+ 4.02331831777773097e-01, 9.15493908848301174e-01,
+-4.02331831777773097e-01,-9.15493908848301174e-01,
+ 4.09471777053295072e-01, 9.12322784872117820e-01,
+-4.09471777053295072e-01,-9.12322784872117820e-01,
+ 4.16586730282041129e-01, 9.09095977415431022e-01,
+-4.16586730282041129e-01,-9.09095977415431022e-01,
+ 4.23676257203938034e-01, 9.05813683425936378e-01,
+-4.23676257203938034e-01,-9.05813683425936378e-01,
+ 4.30739925110803223e-01, 9.02476103237941474e-01,
+-4.30739925110803223e-01,-9.02476103237941474e-01,
+ 4.37777302872755125e-01, 8.99083440560138447e-01,
+-4.37777302872755125e-01,-8.99083440560138447e-01,
+ 4.44787960964527218e-01, 8.95635902463170708e-01,
+-4.44787960964527218e-01,-8.95635902463170708e-01,
+ 4.51771471491683785e-01, 8.92133699366994382e-01,
+-4.51771471491683785e-01,-8.92133699366994382e-01,
+ 4.58727408216736576e-01, 8.88577045028035584e-01,
+-4.58727408216736576e-01,-8.88577045028035584e-01,
+ 4.65655346585160168e-01, 8.84966156526143299e-01,
+-4.65655346585160168e-01,-8.84966156526143299e-01,
+ 4.72554863751304455e-01, 8.81301254251340649e-01,
+-4.72554863751304455e-01,-8.81301254251340649e-01,
+ 4.79425538604203005e-01, 8.77582561890372759e-01,
+-4.79425538604203005e-01,-8.77582561890372759e-01,
+ 4.93078685753923052e-01, 8.69984718058417372e-01,
+-4.93078685753923052e-01,-8.69984718058417372e-01,
+ 5.06611454814257400e-01, 8.62174479934880500e-01,
+-5.06611454814257400e-01,-8.62174479934880500e-01,
+ 5.20020541953727045e-01, 8.54153754277385380e-01,
+-5.20020541953727045e-01,-8.54153754277385380e-01,
+ 5.33302673536020122e-01, 8.45924499231067939e-01,
+-5.33302673536020122e-01,-8.45924499231067939e-01,
+ 5.46454606919203556e-01, 8.37488723850523642e-01,
+-5.46454606919203556e-01,-8.37488723850523642e-01,
+ 5.59473131247366862e-01, 8.28848487609325724e-01,
+-5.59473131247366862e-01,-8.28848487609325724e-01,
+ 5.72355068234507214e-01, 8.20005899897234047e-01,
+-5.72355068234507214e-01,-8.20005899897234047e-01,
+ 5.85097272940462210e-01, 8.10963119505217933e-01,
+-5.85097272940462210e-01,-8.10963119505217933e-01,
+ 5.97696634538701477e-01, 8.01722354098418410e-01,
+-5.97696634538701477e-01,-8.01722354098418410e-01,
+ 6.10150077075791386e-01, 7.92285859677178572e-01,
+-6.10150077075791386e-01,-7.92285859677178572e-01,
+ 6.22454560222343689e-01, 7.82655940026272812e-01,
+-6.22454560222343689e-01,-7.82655940026272812e-01,
+ 6.34607080015269331e-01, 7.72834946152471503e-01,
+-6.34607080015269331e-01,-7.72834946152471503e-01,
+ 6.46604669591152370e-01, 7.62825275710576234e-01,
+-6.46604669591152370e-01,-7.62825275710576234e-01,
+ 6.58444399910567579e-01, 7.52629372418066489e-01,
+-6.58444399910567579e-01,-7.52629372418066489e-01,
+ 6.70123380473162888e-01, 7.42249725458501319e-01,
+-6.70123380473162888e-01,-7.42249725458501319e-01,
+ 6.81638760023334123e-01, 7.31688868873820897e-01,
+-6.81638760023334123e-01,-7.31688868873820897e-01,
+ 6.92987727246317964e-01, 7.20949380945696383e-01,
+-6.92987727246317964e-01,-7.20949380945696383e-01,
+ 7.04167511454533712e-01, 7.10033883566079660e-01,
+-7.04167511454533712e-01,-7.10033883566079660e-01
+};
+
+const double __vlibm_TBL_sincos_lo[] = {
+ 8.88605337234228782e-18, 4.91917302237681002e-17,
+-8.88605337234228782e-18,-4.91917302237681002e-17,
+ 5.81822082653163949e-19, 4.19401745952789211e-17,
+-5.81822082653163949e-19,-4.19401745952789211e-17,
+ 5.48356943034715901e-18,-1.03274445882754459e-17,
+-5.48356943034715901e-18, 1.03274445882754459e-17,
+-1.21877614400540502e-17,-1.63494100549760754e-18,
+ 1.21877614400540502e-17, 1.63494100549760754e-18,
+-9.95477472645292259e-18,-4.92572126294455489e-17,
+ 9.95477472645292259e-18, 4.92572126294455489e-17,
+ 4.43433505081671336e-18,-2.26634179854541132e-17,
+-4.43433505081671336e-18, 2.26634179854541132e-17,
+-1.62404059010738783e-20,-2.16479885316442748e-17,
+ 1.62404059010738783e-20, 2.16479885316442748e-17,
+ 7.94348727702255030e-18,-2.49458400454010874e-17,
+-7.94348727702255030e-18, 2.49458400454010874e-17,
+ 2.34937969012815731e-18,-3.91992037542008779e-17,
+-2.34937969012815731e-18, 3.91992037542008779e-17,
+ 6.04001694249999295e-18, 3.13336233097345808e-17,
+-6.04001694249999295e-18,-3.13336233097345808e-17,
+-7.83274121019861488e-18, 1.96784118087030288e-17,
+ 7.83274121019861488e-18,-1.96784118087030288e-17,
+ 1.16502095128541978e-17,-2.95181339018270543e-17,
+-1.16502095128541978e-17, 2.95181339018270543e-17,
+ 5.58723281546011280e-18, 1.31087695215267578e-17,
+-5.58723281546011280e-18,-1.31087695215267578e-17,
+ 1.06518785731668444e-17,-3.07669849664887505e-17,
+-1.06518785731668444e-17, 3.07669849664887505e-17,
+-5.53640369317216307e-18, 2.99100284927694838e-17,
+ 5.53640369317216307e-18,-2.99100284927694838e-17,
+ 1.22477058822641605e-18,-4.86093565810892311e-17,
+-1.22477058822641605e-18, 4.86093565810892311e-17,
+ 1.11700710733643761e-17,-7.85069060928502747e-18,
+-1.11700710733643761e-17, 7.85069060928502747e-18,
+-1.47298004525206156e-19, 4.12921182559656912e-17,
+ 1.47298004525206156e-19,-4.12921182559656912e-17,
+-1.05859041643290307e-17, 4.99012883492139510e-17,
+ 1.05859041643290307e-17,-4.99012883492139510e-17,
+-4.98254439531455880e-18,-8.05559790337166344e-18,
+ 4.98254439531455880e-18, 8.05559790337166344e-18,
+-8.31808085268720599e-18, 2.39202645464901648e-17,
+ 8.31808085268720599e-18,-2.39202645464901648e-17,
+-9.89486060733470012e-19,-4.18461124842153636e-17,
+ 9.89486060733470012e-19, 4.18461124842153636e-17,
+-7.26081066097971201e-18, 5.12857925321536470e-17,
+ 7.26081066097971201e-18,-5.12857925321536470e-17,
+-9.57516421953495973e-18, 2.52768896842457810e-18,
+ 9.57516421953495973e-18,-2.52768896842457810e-18,
+-7.53102495590705992e-18, 5.07143666240393522e-17,
+ 7.53102495590705992e-18,-5.07143666240393522e-17,
+-2.23100354354259536e-17,-3.23777029770769223e-17,
+ 2.23100354354259536e-17, 3.23777029770769223e-17,
+-2.25345975279021249e-17,-3.03455426810186255e-18,
+ 2.25345975279021249e-17, 3.03455426810186255e-18,
+-1.21032650978877771e-17,-4.64600977172424097e-18,
+ 1.21032650978877771e-17, 4.64600977172424097e-18,
+ 1.76740702627918219e-17,-2.80782706351672909e-17,
+-1.76740702627918219e-17, 2.80782706351672909e-17,
+-1.81620831076181184e-17, 8.13462149294625475e-18,
+ 1.81620831076181184e-17,-8.13462149294625475e-18,
+ 7.51694493032735190e-18,-3.14845086884162891e-17,
+-7.51694493032735190e-18, 3.14845086884162891e-17,
+ 2.60639277793073401e-17, 4.37575894717349784e-17,
+-2.60639277793073401e-17,-4.37575894717349784e-17,
+ 1.10043664427652965e-19,-3.86148346756741172e-17,
+-1.10043664427652965e-19, 3.86148346756741172e-17,
+ 2.85898059254855721e-17, 4.14914804609944515e-17,
+-2.85898059254855721e-17,-4.14914804609944515e-17,
+ 2.09377335812660597e-17,-3.91168333493415196e-17,
+-2.09377335812660597e-17, 3.91168333493415196e-17,
+ 2.35998378957031002e-17,-1.60176532845458484e-17,
+-2.35998378957031002e-17, 1.60176532845458484e-17,
+ 1.03122798607872161e-17,-4.85238302367970955e-18,
+-1.03122798607872161e-17, 4.85238302367970955e-18,
+ 5.88166458751798880e-18, 6.91932945992178774e-18,
+-5.88166458751798880e-18,-6.91932945992178774e-18,
+-2.56162087360699421e-17,-5.23503020396832165e-17,
+ 2.56162087360699421e-17, 5.23503020396832165e-17,
+ 1.74954828401588476e-17,-1.32285954777808795e-17,
+-1.74954828401588476e-17, 1.32285954777808795e-17,
+-9.93881456210652418e-18, 4.48876000332807380e-18,
+ 9.93881456210652418e-18,-4.48876000332807380e-18,
+-2.37566914410618903e-17, 4.53509425735919737e-17,
+ 2.37566914410618903e-17,-4.53509425735919737e-17,
+ 2.13725286462113737e-17, 5.54441253880345633e-17,
+-2.13725286462113737e-17,-5.54441253880345633e-17,
+ 1.75979951033595287e-17,-8.55069309786724315e-18,
+-1.75979951033595287e-17, 8.55069309786724315e-18,
+-1.96134878714142281e-17,-4.05641501045149965e-17,
+ 1.96134878714142281e-17, 4.05641501045149965e-17,
+ 1.44138754527020067e-17, 5.41337556683804221e-17,
+-1.44138754527020067e-17,-5.41337556683804221e-17,
+-5.67940300009126604e-18, 2.63490402114133324e-17,
+ 5.67940300009126604e-18,-2.63490402114133324e-17,
+-9.61085068253371493e-18, 2.92000611384121121e-17,
+ 9.61085068253371493e-18,-2.92000611384121121e-17,
+-2.33180070006887094e-17, 4.28646664908052081e-17,
+ 2.33180070006887094e-17,-4.28646664908052081e-17,
+-2.62128796074765330e-17, 3.11249067465132618e-17,
+ 2.62128796074765330e-17,-3.11249067465132618e-17,
+ 7.64345629962023030e-18, 9.07695177507561595e-18,
+-7.64345629962023030e-18,-9.07695177507561595e-18,
+-6.65539297734492513e-18,-8.85404388576271590e-18,
+ 6.65539297734492513e-18, 8.85404388576271590e-18,
+-8.23407394209890257e-18, 2.31606552113801660e-17,
+ 8.23407394209890257e-18,-2.31606552113801660e-17,
+ 1.60809820962183558e-17,-4.03449199835716708e-17,
+-1.60809820962183558e-17, 4.03449199835716708e-17,
+ 1.45987039105142601e-17,-7.69055777598735693e-18,
+-1.45987039105142601e-17, 7.69055777598735693e-18,
+-3.60879070379054568e-18,-4.97307318930606626e-17,
+ 3.60879070379054568e-18, 4.97307318930606626e-17,
+-5.10396986055601290e-18,-4.26231498642799968e-17,
+ 5.10396986055601290e-18, 4.26231498642799968e-17,
+ 5.60508397387175474e-18, 1.65738511074092287e-17,
+-5.60508397387175474e-18,-1.65738511074092287e-17,
+-3.26941342361816774e-17, 4.41324275781058045e-18,
+ 3.26941342361816774e-17,-4.41324275781058045e-18,
+-3.98326674569845477e-17, 5.42056510267528622e-18,
+ 3.98326674569845477e-17,-5.42056510267528622e-18,
+ 5.12931811503204399e-17, 1.54950664735032887e-17,
+-5.12931811503204399e-17,-1.54950664735032887e-17,
+ 8.39975484092950739e-18, 4.33370260439483957e-17,
+-8.39975484092950739e-18,-4.33370260439483957e-17,
+ 1.57556551448872803e-17, 1.11639354066174440e-17,
+-1.57556551448872803e-17,-1.11639354066174440e-17,
+ 2.65758723572153157e-17,-3.91243174820912803e-17,
+-2.65758723572153157e-17, 3.91243174820912803e-17,
+-5.48839724611618050e-17,-3.09133348612217870e-17,
+ 5.48839724611618050e-17, 3.09133348612217870e-17,
+ 5.45032359305438502e-17, 4.01345333110870077e-17,
+-5.45032359305438502e-17,-4.01345333110870077e-17,
+-1.47982699075898800e-17,-2.90497793128345697e-17,
+ 1.47982699075898800e-17, 2.90497793128345697e-17,
+-6.04903576570970714e-18,-1.47407164121148702e-17,
+ 6.04903576570970714e-18, 1.47407164121148702e-17,
+-3.45685823926249648e-17, 4.23101492189102265e-17,
+ 3.45685823926249648e-17,-4.23101492189102265e-17,
+ 4.56764771439328899e-19, 1.66729950215466278e-17,
+-4.56764771439328899e-19,-1.66729950215466278e-17,
+-3.77363867003067107e-17,-1.29709930131505256e-17,
+ 3.77363867003067107e-17, 1.29709930131505256e-17,
+ 6.18353672557495936e-18,-1.23393036048695210e-17,
+-6.18353672557495936e-18, 1.23393036048695210e-17,
+ 4.41046731319790287e-17,-1.04758243065127675e-17,
+-4.41046731319790287e-17, 1.04758243065127675e-17,
+-5.35432907989094549e-17, 3.49498670147881544e-17,
+ 5.35432907989094549e-17,-3.49498670147881544e-17,
+-3.94095700584824985e-17, 1.50527221189129099e-17,
+ 3.94095700584824985e-17,-1.50527221189129099e-17,
+};